
local Client = NetTest:addState('Client')
function Client:enterState()
  clearLoveCallbacks()
  
  ID = nil
  xp = -1
  yp = -1
  mice = {}
  
  print("initializing client")
  function onReceive(data)
    local t = table.load(data)
    if t.selfID then
      self.ID = t.ID
    elseif t.sessionEnd then
      netTest:gotoState('Menu')
    else
      mice = t
    end
  end
  client = lube.client()
  client:setHandshake("Hi!")
  client:setPing(true, 5, "q!/\8vj903sdcj")
  client:setCallback(onReceive)
  client:connect("127.0.0.1", 18025)
  print("initialized client")
  
  function love.update(dt)
    client:update(dt)
    local x, y = love.mouse.getPosition()
    if self.ID then
      if xp ~= x and yp ~= y then
        local mouse = {x = x,y = y,ID = self.ID}
        client:send(table.save(mouse))
        xp = x
        yp = y
      end
    end
  end
  function love.draw()
    for _,v in ipairs(mice) do
      if v.ID ~= self.ID then
        love.graphics.circle("line",v.x,v.y,20,48)
      end
    end
  end
  function love.keypressed(k)
    if k=='escape' then
      netTest:gotoState('Menu')
    end
  end
  function love.quit()
    client:disconnect()
  end
end
function Client:exitState()
  print("Exiting client")
   client:disconnect()
end
