
local Server = NetTest:addState('Server')
function Server:enterState()
  clearLoveCallbacks()
  
  mice = {}
  
  print("initializing server")
  function onConnect(ip, port)
    print("Connection from " .. ip)
    local t = {ID = ip, selfID = true}
    local st = table.save(t)
    server:send(st,ip)
  end
  function onReceive(data, ip, port)
    local t = table.load(data)
    if mice[t.ID] then
      mice[t.ID].x = t.x
      mice[t.ID].y = t.y
    else
      table.insert(mice,t)
    end
    for _,c in ipairs(mice) do
      if ip ~= c.ID then
        server:send(table.save(mice),c.ID)
      end
    end
  end
  function onDisconnect(ip, port)
    for i,c in ipairs(mice) do
      if c.ID == ip then
        table.remove(mice,i)
        break
      end
    end
  end
  server = lube.server(18025)
  server:setCallback(onReceive, onConnect, onDisconnect)
  server:setHandshake("Hi!")
  server:setPing(true, 15, "q!/\8vj903sdcj")
  print("initialized server")
  
  function love.update(dt)
    server:update(dt)
  end
  function love.draw()
    for _,v in ipairs(mice) do
      love.graphics.circle("line",v.x,v.y,20,48)
    end
  end
  function love.keypressed(k)
    if k=='escape' then
      netTest:gotoState('Menu')
    end
  end
end
function Server:exitState()
  --TODO: Server EXIT CODE
  print("Exiting server")
  server:send(table.save({sessionEnd = true}))
  self.server = nil
end
